import 'package:bloc_stream/bloc_stream.dart';
import 'package:test/test.dart';

class CounterActions {
  static Stream<int> increment(int currentValue, CounterBloc _bloc) async* {
    yield currentValue + 1;
  }

  static Stream<int> decrement(int currentValue, CounterBloc _bloc) async* {
    yield currentValue - 1;
  }
}

class CounterBloc extends BlocStream<int> {
  CounterBloc() : super(0);
}

void main() {
  group('CounterBloc', () {
    test('increments and decrements correctly', () {
      final counter = CounterBloc();
      assert(counter.value == 0);
      counter.add(CounterActions.increment);
      assert(counter.value == 1);
      counter.add(CounterActions.decrement);
      assert(counter.value == 0);
    });
  });
}
